#!/usr/local/bin/perl

#
# Ultimate Bulletin Board is copyright Infopop Corporation, 1998-2000.
#
#       ------------ announce.cgi -------------
#
print ("Content-type: text/html\n\n");
eval {
  ($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1"); # Get the script location: UNIX / or Windows /
  ($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1"); # Get the script location: Windows \
 
#substitute all require files here for the file

require "UltBB.setup";
require "ubb_library.pl";
require "ubb_library2.pl";
require "mods.file";
require "Date.pl";
};

if ($@) {
    print "Error including required files: $@\n";
    print "Make sure these files exist, permissions are set properly, and paths are set correctly.";
 exit;
}

&ReadParse;

if ($in{'action'} eq "center") {
&Center;
}

if ($in{'action'} eq "enter") {
&Enter;
}

if ($in{'action'} eq "submitanncedit") {
&SubmitEdit;
}

if ($in{'action'} eq "reviewannounce") {
&RetrieveAnnounce;
}
if ($in{'action'} eq "submitannounce") {
&SubmitNew;
}

sub SubmitEdit {
$GetAll = "";
$UserName = $in{'UserName'};
#re-confirm user
$ProfileNumber = &GetUserNumber($UserName);
@theprofile = &OpenProfile("$ProfileNumber.cgi");
	if ($in{'Password'} eq "$theprofile[1]") {
				$Status = $theprofile[8];
				&CheckStatus;
					   	if (($AdminStatus eq "true") || ($ModStatus eq "true")) {
					&ProceedWithEditWrite;
				} else {
					&StandardHTML("Sorry, but you are not authorized to perform this function.  Use your Back button.");
				}
 	}  else {
		&StandardHTML("Sorry, but the password you entered was not correct.  Please try again.  Use your Back button.");
	}


} #end Submit Edit sr


sub RetrieveAnnounce {
## Get current announcement info from file
@thisannc = &OpenFile("$in{'EditAnnounce'}");
$message = $thisannc[4];
chomp($message);
$author = $thisannc[0];
chomp($author);
$subject = $thisannc[1];
chomp($subject);
$forumslist = $thisannc[3];
chomp($forumslist);
$status = $thisannc[2];
chomp($status);

	$message =~ s/<p>/\n\r\n/ig;
	$message =~ s/<br>/\n/ig;
	$message =~ s/<IMG SRC="$NonCGIURL\/smile.gif">/:\)/isg;
	$message =~ s/<IMG SRC="$NonCGIURL\/frown.gif">/:\(/isg;
$message =~ s/<IMG SRC="$NonCGIURL\/biggrin.gif">/\:D/isg;
$message =~ s/<IMG SRC="$NonCGIURL\/wink.gif">/\;\)/isg;
$message =~ s/<IMG SRC="$NonCGIURL\/redface.gif">/\:o/isg;

#convert UBB Code
$UBBImages = "ON";
$OverrideImages = "no";
$message = &EditUBBConvert("$message");

#Retrieve names of each forum where displayed
if ($forumslist eq "ALL") {
$forumnames = "All";
} else {
@forumnames = split(/\|/, $forumslist);
foreach $forumname(@forumnames) {
	@theforum = &GetForumRecord($forumname);
	if ($forumnames ne "") {
	$forumnames .= ", $theforum[1]";
	} else {
		$forumnames = "$theforum[1]";
	}
}
}

#get start, end dates
(@splitit) = split("/", $in{'EditAnnounce'});
@sortedfiles = grep(/.annc/, @splitit);
$announcefile = $sortedfiles[0];

$EndMonth = substr($announcefile, 9, 2);
$EndDay = substr($announcefile, 11, 2);
$EditEndYear = substr($announcefile, 13, 4);
$StartMonth = substr($announcefile, 0, 2);
$StartDay = substr($announcefile, 2, 2);
$EditStartYear = substr($announcefile, 4, 4);



print <<EditFORM;
<HTML><HEAD>
<TITLE>
$BBName - Edit this announcement
</TITLE>
</HEAD>
 <BODY BGCOLOR="#FFFFFF" link="#000080" vlink="#800080">
<CENTER>
<FONT SIZE="5" FACE="Courier New"><B>Review/Edit Announcement</B></FONT>
<P>
<FONT SIZE="2" FACE="Verdana, Arial">Note: Only administrators or moderators may edit this announcement.<br>
</FONT>
</CENTER>
<ul>
<FORM ACTION="$CGIURL/announce.cgi" NAME="REPLIER" METHOD="POST">
<table border=0>
<tr><td>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000000">Your UserName:</FONT></td>
<td>
<INPUT TYPE="TEXT" NAME="UserName" VALUE="" SIZE=25 MAXLENGTH=25>
</td>
</tr>
<tr>
<td>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000000">Your Password:</FONT></td>
<td><INPUT TYPE="PASSWORD" NAME="Password" VALUE=""  SIZE=13 MAXLENGTH=13>&nbsp;&nbsp;<FONT SIZE="1" FACE="Verdana, Arial"><A HREF="Ultimate.cgi?action=lostpw">Forget your password?</A></font>
</td></tr>
<tr>
<td>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000000">Subject:</FONT></td>
<td><INPUT TYPE="TEXT" NAME="Subject" VALUE="$subject"  SIZE=35 MAXLENGTH=200>
</td></tr>
<TR><TD valign=top>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000000">Announcement to Edit:</FONT><p>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#800000">
You may use HTML and/or UBB Code</p></font></td>
<td><FONT SIZE="1" FACE="Verdana, Arial" COLOR="#800000">Originally posted by $author<BR></FONT>
<TEXTAREA NAME="EditedMessage" ROWS=10 COLS=45 WRAP="VIRTUAL">$message</TEXTAREA>
</td></tr>
<TR>
<TD><FONT SIZE="2" FACE="Verdana, Arial">
<B>Forum(s) Where <BR>
Announcement Is Displayed</B></font>
</td>
<td>
<FONT SIZE="2" FACE="Verdana, Arial">
$forumnames</font>
</td>
</tr>

<TR>
<TD><FONT SIZE="2" FACE="Verdana, Arial">
<B>Start Date</B></font>
</td>
<td>
EditFORM

&DateTable("StartMonth", "StartDay", "StartYear");


print<<EditFORM2;
</td>
</tr>
<TR>
<TD><FONT SIZE="2" FACE="Verdana, Arial">
<B>End Date</B></font>
</td>
<td>
EditFORM2

&DateTable("EndMonth", "EndDay", "EndYear");

print<<EditFORM3;
</td>
</tr>

<TR>
<TD colspan=2 align=center>
<FONT SIZE="2" FACE="Verdana, Arial"><B>To delete this announcement, check this box ->&nbsp;&nbsp;<INPUT TYPE="CHECKBOX" NAME="Delete" VALUE="yes"></B></FONT>

</td>
</tr>

</table>
<p>
<INPUT TYPE="HIDDEN" NAME="anncfile" VALUE="$announcefile">
<INPUT TYPE="HIDDEN" NAME="forumslist" VALUE="$forumslist">
<INPUT TYPE="HIDDEN" NAME="action" VALUE="submitanncedit">
<INPUT TYPE="HIDDEN" NAME="ForumList" VALUE="$forumlist">
<CENTER>
<p>
<INPUT TYPE="Submit" NAME="SUBMIT" VALUE="Submit Edited Announcement">
<INPUT TYPE="RESET" NAME="RESET" VALUE="Clear Fields">
</form>
<P>
<SCRIPT LANGUAGE="JavaScript">
<!-- HIDE
var dc = document.cookie;
var testUserName = getCookie("UserNameCP");
var testPassword = getCookie("PasswordCP");

if (document.cookie) {

	if (testUserName == null) {  
document.REPLIER.UserName.focus();
	} else {
	document.REPLIER.UserName.value = getCookie("UserNameCP");
document.REPLIER.Password.value = getCookie("PasswordCP");
document.REPLIER.EditedMessage.focus();
	}
}  else {
document.REPLIER.UserName.focus();
}

function getCookie(name){
var cname = name + "=";               
var dc = document.cookie;
if (dc.length > 0) {              
    begin = dc.indexOf(cname);
	 if (begin != -1) {           
        begin += cname.length;
		end = dc.indexOf(";", begin);
            if (end == -1) end = dc.length;
            return unescape(dc.substring(begin, end));        }
}
return null;
}

// STOP HIDING FROM OTHER BROWSERS -->
</SCRIPT>
</ul>
<P>
<B><FONT SIZE="2" FACE="Verdana, Arial">
<A HREF="$ContactLink">Contact Us</A> | <A HREF="$HomePageURL" target=_top>$MyHomePage</A> $PrivacyStatement
</B>
<p><FONT COLOR="$CopyrightTextColor" size="1" FACE="$FontFace">
$infopopcopy<br>
Ultimate Bulletin Board $Version
<br><br></font>
</FONT>
</CENTER>
</body></html>
EditFORM3
}


sub SubmitNew {
$GetAll = "";
$UserName = $in{'UserName'};
#re-confirm user
$ProfileNumber = &GetUserNumber($UserName);

@theprofile = &OpenProfile("$ProfileNumber.cgi");
	if ($in{'Password'} eq "$theprofile[1]") {
				$Status = $theprofile[8];
				&CheckStatus;
					   	if (($AdminStatus eq "true") || ($ModStatus eq "true")) {
					&ProceedWithNew;
				} else {
					&StandardHTML("Sorry, but you are not authorized to perform this function.  Use your Back button.");
				}
 	}  else {
		&StandardHTML("Sorry, but the password you entered was not correct.  Please try again.  Use your Back button.");
	}
}  # End SubmitNew sr


sub ProceedWithNew {

for $getnumbers(@in) {
	($Name, $Value) = split ("=", $getnumbers);
	$Name = &decodeURL($Name);
	$Value = &decodeURL($Value);
	if ($Name eq "ForumNumber") {
		if ($Value ne "ALL") {
		($trash, $thenumber) = split(/orum/, $Value);
		push(@anncforums, $thenumber);
		}  else {
		$GetAll = "true";
		}
	}
}

#format dates

$StartDate = ("$in{'StartMonth'}" . "$in{'StartDay'}" . "$in{'StartYear'}");
$EndDate = ("$in{'EndMonth'}" . "$in{'EndDay'}" . "$in{'EndYear'}");
&GetTime;  #retrieve time for use in filename --> $timestamp

$FileName = ("$StartDate-$EndDate-$timestamp.annc");
$Message = "$in{'EditedMessage'}";

$UBBImages = "ON";
$OverrideImages = "no";

#convert carriage returns, UBB Code, and smilies
$Message = &ConvertReturns("$Message");
$Message = &UBBCode("$Message");
$Message = &Smilies("$Message");


#print announcement to applicable forum(s)

$addtoit = "";
for $that(@anncforums) {
chomp($that);
if ($addtoit eq "") {
$addtoit = "$that";
} else {
$addtoit .= "|$that";
}
}

if ($GetAll ne "true") {

foreach $thisuno(@anncforums) {
chomp($thisuno);
@thisforum = &GetForumRecord($thisuno);

if ($thisforum[6] eq "private") {
	$ExactPath = "Forum$thisuno/private-$thisforum[7]";
}  else {
	$ExactPath = "Forum$thisuno";
}

unless (-d "$ForumsPath/$ExactPath/ANNC") {
mkdir("$ForumsPath/$ExactPath/ANNC", 0777);
chmod (0777, "$ForumsPath/$ExactPath/ANNC");
}

open (THISFORUM, ">$ForumsPath/$ExactPath/ANNC/$FileName");
print THISFORUM ("$UserName\n");
print THISFORUM ("$in{'Subject'}\n");
print THISFORUM ("$Status\n");
print THISFORUM ("$addtoit\n");
print THISFORUM ("$Message\n");
close(THISFORUM);
chmod(0777, "$ForumsPath/$ExactPath/ANNC/$FileName");
}
}  else {
#add announcement to all forums!
@allforums = &OpenForumsFile;

for $eachforum(@allforums) {
@foruminfo = split(/\|/, $eachforum);
$ForumNumber = "$foruminfo[8]";
if ($foruminfo[6] eq "private") {
	$ExactPath = "Forum$ForumNumber/private-$foruminfo[7]";
}  else {
	$ExactPath = "Forum$ForumNumber";
}
open (THISFORUM, ">$ForumsPath/$ExactPath/ANNC/$FileName");
print THISFORUM ("$UserName\n");
print THISFORUM ("$in{'Subject'}\n");
print THISFORUM ("$Status\n");
print THISFORUM ("ALL\n");
print THISFORUM ("$Message\n");
close(THISFORUM);
chmod(0777, "$ForumsPath/$ExactPath/ANNC/$FileName");
}
}

#print confirmation on screen
print <<Confirm;
<HTML>
 <BODY BGCOLOR="#FFFFFF" link="#000080" vlink="#800000">
<B><CENTER><FONT FACE="Courier New" SIZE="5">
Announcement Added!</B></font></center>
<P>
</BODY></HTML>
Confirm
} #end ProceedWithNew sr


sub ProceedWithEditWrite {
if ($AdminStatus eq "true") {
$Status = "Administrator";
}  else {
$Status = "Moderator";
}
###  Determine Edited File Name ##############

$StartDate = ("$in{'StartMonth'}" . "$in{'StartDay'}" . "$in{'StartYear'}");
$EndDate = ("$in{'EndMonth'}" . "$in{'EndDay'}" . "$in{'EndYear'}");
&GetTime;  #retrieve time for use in filename -- > $timestamp
$NewFileName = ("$StartDate-$EndDate-$timestamp.annc");

################################################

## Format the message text 

$Message = "$in{'EditedMessage'}";
$UBBImages = "ON";
$OverrideImages = "no";

#convert carriage returns, UBB Code, and smilies
$Message = &ConvertReturns("$Message");
$Message = &UBBCode("$Message");
$Message = &Smilies("$Message");

####  process the edit!

if ($in{'forumslist'} eq "ALL") {
$ForumTotal = &GetTotalForums;
for ($x = 1; $x <= $ForumTotal; $x++) {
&GetExactPath($x);
	#delete previous announcement in all applicable forums
	#must delete, because date changes require new file name
	
	unlink ("$ForumsPath/$ExactPath/ANNC/$in{'anncfile'}");
	unless ($in{'Delete'} eq "yes") {
	#write edited announcement
	
open (THISFORUM, ">$ForumsPath/$ExactPath/ANNC/$NewFileName");
print THISFORUM ("$UserName\n");
print THISFORUM ("$in{'Subject'}\n");
print THISFORUM ("$Status\n");
print THISFORUM ("ALL\n");
print THISFORUM ("$Message\n");
close(THISFORUM);
}
} #end for $x

}  else {
#update announcement in applicable forums
if ($in{'forumslist'} =~ /\|/) {
@forumnums = split(/\|/, $in{'forumslist'});
}  else {
@forumnums = $in{'forumslist'};
}
foreach $oneforum(@forumnums) {
chomp($oneforum);
&GetExactPath("$oneforum");

unlink ("$ForumsPath/$ExactPath/ANNC/$in{'anncfile'}");
	
	#write edited announcement
	unless ($in{'Delete'} eq "yes") {
open (THISFORUM, ">$ForumsPath/$ExactPath/ANNC/$NewFileName");
print THISFORUM ("$UserName\n");
print THISFORUM ("$in{'Subject'}\n");
print THISFORUM ("$Status\n");
print THISFORUM ("$in{'forumslist'}\n");
print THISFORUM ("$Message\n");
close(THISFORUM);
} #end delete check
} #end foreach $oneforum

}  # end if/else ALL/selected forums

#print confirmation on screen
print <<Confirm;
<HTML>
 <BODY BGCOLOR="#FFFFFF" link="#000080" vlink="#800000">
<B><CENTER><FONT FACE="Courier New" SIZE="5">
Announcement Updated!</B></font></center>
<P>
</BODY></HTML>
Confirm
} #end ProceedWithEditWrite sr

sub Enter {

## identify user-- moderator/administrator/neither
$NameFound = "no";
$UserName = "$in{'UserName'}";
$UserNameFile = $UserName;
$UserNameFile =~ s/ /_/g; #remove spaces
$ProfileNumber = &GetUserNumber($UserName);
if ($ProfileNumber ne "") {
	$NameFound = "yes";
} else {
	$NameFound = "no";
}

&decodeURL("$in{'Password'}");

if ($NameFound eq "yes") {
@profilestats = &OpenProfile("$ProfileNumber.cgi");
	
	if ($in{'Password'} eq "$profilestats[1]") {
	$Status = "$profilestats[8]";
	&CheckStatus;
	   if ($AdminStatus eq "true") {
		if ($in{'AnnounceFunction'} eq "CreateAnnouncement") {
	   &Announce("Admin");
		}  else {
		&Edit("Admin");
		}
	   } 
	    elsif ($ModStatus eq "true") {
			if ($in{'AnnounceFunction'} eq "CreateAnnouncement") {
	   &Announce("Mod");
			}  else {
			&Edit("Mod");
			}
  		}
		else  {
	   &StandardHTML("Sorry, but you are not authorized to perform this function.  Use your Back button.");
	   }
	} else {
	&StandardHTML("Sorry, but the password you entered was not correct.  Please try again.  Use your Back button.");
	}
}  else {
&StandardHTML("Sorry, but no one is registered with the User Name you listed.  Please try again.  Use your Back button.");
}  ##END IF/ELSE NAME CHECK BLOCK
} # end Enter sr


sub GetTime {
($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime (time);
$hour = sprintf ("%2d", $hour);
$hour =~tr/ /0/;
$min = sprintf ("%2d", $min);
$min =~tr/ /0/;
$sec = sprintf ("%2d", $sec);
$sec =~tr/ /0/;

	$Year = (1900 + $year);

$timestamp = ("$hour" . "$min" . "$sec");
}

sub Center {
print<<CenterHTML;
<HTML>
<HEAD>
	<TITLE>$BBTitle- Anouncement Center (Control Panel)</TITLE>
<SCRIPT LANGUAGE="JavaScript">
<!-- HIDE
function SetCursor() {
var testUserNameCP = getCookie("UserNameCP");

if (testUserNameCP != null) {  
	document.THEFORM.UserName.value = getCookie("UserNameCP");
document.THEFORM.Password.value = getCookie("PasswordCP");
	}  else {
	document.THEFORM.UserName.focus();
}
}

function Check(form)  {
if ((form.Password.value == "") || (form.UserName.value == ""))  {
	alert ("You forgot to fill in the Username and/or Password fields.  These are required entries!");
	return false
	}  else  {
	return true
	}
}

function getCookie(name){
var cname = name + "=";               
var dc = document.cookie;
if (dc.length > 0) {              
    begin = dc.indexOf(cname);
	 if (begin != -1) {           
        begin += cname.length;
		end = dc.indexOf(";", begin);
            if (end == -1) end = dc.length; 
            return unescape(dc.substring(begin, end));  }
}
return null;
}
// STOP HIDING FROM OTHER BROWSERS -->
</SCRIPT>
</HEAD>
<BODY bgcolor="#FFFFFF" link="#000080" vlink="#808000" onLoad="SetCursor()">

<FONT SIZE="2" FACE="Verdana, Arial">

<BR>
<B><CENTER><FONT FACE="Courier New" SIZE="5">Announcement Center</FONT></B></CENTER>


<FORM ACTION="$CGIURL/announce.cgi" METHOD="POST" NAME="THEFORM" onSubmit="return Check(this)">
<CENTER>
<table border=0 cellpadding=0 cellspacing=0 width=90%>
<TR><TD bgcolor="#000000">

<table border=0 width=100%>
<TR bgcolor="#D5D2BB">
<td>
<FONT FACE="Verdana" SIZE="2"><B>Identify Yourself:</b></FONT>
</td>
<td>
<FONT FACE="Verdana" SIZE="2"><B>Select One:</b></FONT>
</td>
</tr>

<TR bgcolor="#C7C6BA"><TD>
<FONT SIZE="1" FACE="Verdana, Arial"><B>Your User Name<BR>
<INPUT TYPE="TEXT" NAME="UserName" SIZE=25 MAXLENGTH=25>
<P>
Your Password</FONT></B><BR>
<INPUT TYPE="PASSWORD" NAME="Password" SIZE=13 MAXLENGTH=13>
</td>

<td>

<INPUT TYPE="RADIO" NAME="AnnounceFunction" VALUE="CreateAnnouncement" CHECKED>&nbsp;&nbsp;
<FONT SIZE="1" FACE="Verdana"><B>
Create New Announcement
<BR>
<INPUT TYPE="RADIO" NAME="AnnounceFunction" VALUE="EditAnnouncement">
&nbsp;&nbsp;
Review/Edit Announcements</B></FONT>
</td></tr>
<tr bgcolor="#CAB5A6"><td colspan=2>
<center>
<INPUT TYPE="Hidden" NAME="action" VALUE="enter">
<INPUT TYPE="SUBMIT" NAME="Submit" VALUE="Submit Choice">
</center>
</td></tr>
</table>
</td></tr></table>

</FORM>
<P>
<FONT SIZE="1" FACE="Verdana, Arial">Note: only moderators and administrators may create, review, or edit announcements. </FONT>
</CENTER>
</BODY></HTML>
CenterHTML
}


sub Announce {

$Type = shift;
$UserName = "$in{'UserName'}";
$Password = "$in{'Password'}";

## grab current year to fill into form fields
&GetTime; #retrieving $Year (4-digit)

print <<HTMLbob;
<HTML><HEAD>
<TITLE>
$BBName - Write Announcement</TITLE>
<script language="JavaScript"> 
<!-- HIDE
var testUserNameCP = getCookie("UserNameCP");
var CookieUNCP = escape("$UserName");
var CookiePWCP = escape("$Password");

	if (testUserNameCP == null) {
	  	document.cookie = "UserNameCP=" + CookieUNCP + ";";
		document.cookie = "PasswordCP=" + CookiePWCP + ";";
	}


function getCookie(name){
var cname = name + "=";               
var dc = document.cookie;
if (dc.length > 0) {              
    begin = dc.indexOf(cname);
	 if (begin != -1) {           
        begin += cname.length;
		end = dc.indexOf(";", begin);
            if (end == -1) end = dc.length;
            return unescape(dc.substring(begin, end));        }
}
return null;
}
//-->
</script>

</HEAD>
 <BODY BGCOLOR="#FFFFFF" text="#000000" link="#000080" vlink="#808000">
<B><CENTER><FONT FACE="Courier New" SIZE="5">Create New Announcement</b></font>
<P>
<FONT SIZE="2" FACE="Verdana, Arial">Note: Only administrators and moderators may post announcements.<br>
</FONT>
</CENTER>
<ul>
<FORM ACTION="$CGIURL/announce.cgi" NAME="REPLIER" METHOD="POST">
<table border=0>
<tr><td>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000000">Your UserName:</FONT></td>
<td>
<INPUT TYPE="TEXT" NAME="UserName" VALUE="" SIZE=25 MAXLENGTH=25>
</td>
</tr>
<tr>
<td>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000000">Your Password:</FONT></td>
<td><INPUT TYPE="PASSWORD" NAME="Password" VALUE=""  SIZE=13 MAXLENGTH=13>&nbsp;&nbsp;<FONT SIZE="1" FACE="Verdana, Arial"><A HREF="Ultimate.cgi?action=lostpw">Forget your password?</A></font>
</td></tr>
<tr><td>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000000">Subject:</FONT></td>
<td>
<INPUT TYPE="TEXT" NAME="Subject" VALUE="" SIZE=30 MAXLENGTH=100>
</td>
</tr>
<TR><TD valign=top>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000000">Your Announcement:</FONT><p>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#808000">
You may use HTML and/or <A HREF="$NonCGIURL/ubbcode.html" target=_new>UBB Code</a><BR>
in your message<BR>
</font></td>
<td>
<TEXTAREA NAME="EditedMessage" ROWS=10 COLS=30 WRAP="VIRTUAL">$message</TEXTAREA>
</td></tr>
<TR><TD valign=top>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000000">Forums To Post Announcement To:</FONT>
</td>
<td>
<SELECT NAME="ForumNumber" SIZE=5 MULTIPLE>
HTMLbob


#FILL IN FORUM FIELDS HERE


if ($Type eq "Mod") {
#Get List of All Forums
$ForumTotal = &GetTotalForums;
for ($x = 1; $x <= $ForumTotal; $x++) {
@thisforum = &GetForumRecord($x);
$ForumModerator = ("Forum" . "$x" . "Moderator");
$ForumModerator = $$ForumModerator;
@mods = split(/\|\|\^\|\|/, $ForumModerator);

$ModMatch = "";
foreach $unomod(@mods) {
if ($unomod eq "$UserName") {
	$ModMatch = "true";
}
}

	if (($thisforum[3] eq "On") && ($ModMatch eq "true")){
print<<Forum1HTML;
<OPTION VALUE="Forum$x">$thisforum[1]
Forum1HTML
	}
} #End for $x--

} #end if Mod


if ($Type eq "Admin") {
$ForumTotal = &GetTotalForums;

if ($ForumTotal > 1) {
print<<ALLhtml;
<OPTION VALUE="ALL">All Forums
ALLhtml
}

for ($x = 1; $x <= $ForumTotal; $x++) {
@thisforum = &GetForumRecord($x);

if ($thisforum[3] eq "On") {
print<<ForumHTML;
<OPTION VALUE="Forum$x">$thisforum[1]
ForumHTML
}
} #END for $x -------

}


print<<HTMLfelix;
</select></td></tr>
<TR><TD valign=top>
<FONT SIZE="2" FACE="Verdana, Arial">Start Date:</FONT><BR>
<FONT SIZE="1" FACE="$Verdana, Arial" COLOR="#808000">
The announcement will appear <br>
when you designate.<BR>
</font>
</td>
<td>
HTMLfelix

&DateTable("StartMonth", "StartDay", "StartYear");

print<<HTMLcarol;
</td></tr>
<TR><TD valign=top>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000000">End Date:</FONT><BR>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#808000">
The announcement will stop appearing <br>
when you designate.<BR>
</font>
</td>
<td>
HTMLcarol

&DateTable("EndMonth", "EndDay", "EndYear");


print<<HTMLalice;
</td></tr>
</table>
<p>
<INPUT TYPE="HIDDEN" NAME="action" VALUE="submitannounce">
<CENTER>
 <FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000080">

</font>
<p>
<INPUT TYPE="Submit" NAME="SUBMIT" VALUE="Submit Announcement">
<INPUT TYPE="RESET" NAME="RESET" VALUE="Clear Fields">
</form>
<P>
<SCRIPT LANGUAGE="JavaScript">
<!-- HIDE
var dc = document.cookie;
var testUserName = getCookie("UserNameCP");
var testPassword = getCookie("PasswordCP");

if (document.cookie) {

	if (testUserName == null) {  
document.REPLIER.UserName.focus();
	} else {
	document.REPLIER.UserName.value = getCookie("UserNameCP");
document.REPLIER.Password.value = getCookie("PasswordCP");
document.REPLIER.Subject.focus();
	}
}  else {
document.REPLIER.UserName.focus();
}

function getCookie(name){
var cname = name + "=";               
var dc = document.cookie;
if (dc.length > 0) {              
    begin = dc.indexOf(cname);
	 if (begin != -1) {           
        begin += cname.length;
		end = dc.indexOf(";", begin);
            if (end == -1) end = dc.length;
            return unescape(dc.substring(begin, end));        }
}
return null;
}

// STOP HIDING FROM OTHER BROWSERS -->
</SCRIPT>

</ul>
<P>
</body></html>
HTMLalice

}  #end Announce sr


sub Edit {

$Type = shift;
$UserName = "$in{'UserName'}";
$Password = "$in{'Password'}";

print <<HTMLbob;
<HTML><HEAD>
<TITLE>
$BBName - Review/Edit Announcement</TITLE>
<script language="JavaScript"> 
<!-- HIDE
var testUserNameCP = getCookie("UserNameCP");
var CookieUNCP = escape("$UserName");
var CookiePWCP = escape("$Password");

	if (testUserNameCP == null) {
	  	document.cookie = "UserNameCP=" + CookieUNCP + ";";
		document.cookie = "PasswordCP=" + CookiePWCP + ";";
	}


function getCookie(name){
var cname = name + "=";               
var dc = document.cookie;
if (dc.length > 0) {              
    begin = dc.indexOf(cname);
	 if (begin != -1) {           
        begin += cname.length;
		end = dc.indexOf(";", begin);
            if (end == -1) end = dc.length;
            return unescape(dc.substring(begin, end));        }
}
return null;
}
//-->
</script>

</HEAD>
 <BODY BGCOLOR="#FFFFFF" link="#000080" vlink="#808000">
<B><CENTER><FONT FACE="Courier New" SIZE="5">Review/Edit Announcements</b></font>
<P>
<FONT SIZE="2" FACE="Verdana, Arial">Note: Only administrators and moderators may review or edit announcements.<br>
</FONT>
</CENTER>
<ul>
<FORM ACTION="$CGIURL/announce.cgi" NAME="REPLIER" METHOD="POST">
<table border=0>
<tr><td>
<FONT SIZE="2" FACE="Verdana, Arial">Your UserName:</FONT></td>
<td>
<INPUT TYPE="TEXT" NAME="UserName" VALUE="" SIZE=25 MAXLENGTH=25>
</td>
</tr>
<tr>
<td>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000000">Your Password:</FONT></td>
<td><INPUT TYPE="PASSWORD" NAME="Password" VALUE=""  SIZE=13 MAXLENGTH=13>&nbsp;&nbsp;<FONT SIZE="1" FACE="Verdana, Arial"><A HREF="Ultimate.cgi?action=lostpw">Forget your password?</A></font>
</td></tr>
</table>
<BR>
<FONT FACE="Verdana, Arial" SIZE="2"><B>Current Announcements You May Review:</B></FONT>
<FORM ACTION="$CGIURL/announce.cgi" METHOD="POST">
<TABLE BORDER=0 width=90%>
<TR bgcolor="#f7f7f7"><TD>
</td>
<TD>
<FONT Size="1" FACE="Verdana, Arial"><B>Announcement</B></FONT>
</td>
<td><b><FONT Size="1" FACE="Verdana, Arial">
Forums</B></FONT>
</td>
<TD><FONT Size="1" FACE="Verdana, Arial">
<B>Start Date</B></FONT>
</td>
<td><b><FONT Size="1" FACE="Verdana, Arial">
End Date</B></FONT>
</td>
</tr>
HTMLbob

#FILL IN FORUM FIELDS HERE
if ($Type eq "Mod") {
#Get List of All Forums
$ForumTotal = &GetTotalForums;
$ForumListTally = "";
for ($x = 1; $x <= $ForumTotal; $x++) {
@thisforum = &GetForumRecord($x);
$ForumModerator = ("Forum" . "$x" . "Moderator");
$ForumModerator = $$ForumModerator;

@mods = split(/\|\|\^\|\|/, $ForumModerator);

$ModMatch = "";
foreach $unomod(@mods) {
if ($unomod eq "$UserName") {
	$ModMatch = "true";
}
}

	if (($thisforum[3] eq "On") && ($ModMatch eq "true")){
		if ($ForumListTally eq "") {
			$ForumListTally = ("$x");
			} else {
			$ForumListTally .= ("|$x");
		}
	}
} #End for $x--
&GetForumAnnouncements("$ForumListTally");
} #end if Mod


if ($Type eq "Admin") {
$ForumTotal = &GetTotalForums;

for ($x = 1; $x <= $ForumTotal; $x++) {
@thisforum = &GetForumRecord($x);

if ($thisforum[3] eq "On") {
	if ($ForumListTally eq "") {
			$ForumListTally = ("$x");
			} else {
			$ForumListTally .= ("|$x");
		}
}
} #END for $x -------
&GetForumAnnouncements("$ForumListTally");
}

print<<HTMLalice;
</table>
<p>
<INPUT TYPE="HIDDEN" NAME="action" VALUE="reviewannounce">
<CENTER>
 <FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000080">

</font>
<p>
<INPUT TYPE="Submit" NAME="SUBMIT" VALUE="Retrieve Announcement">
<INPUT TYPE="RESET" NAME="RESET" VALUE="Clear Fields">
</form>
<P>
<SCRIPT LANGUAGE="JavaScript">
<!-- HIDE
var dc = document.cookie;
var testUserName = getCookie("UserNameCP");
var testPassword = getCookie("PasswordCP");

if (document.cookie) {

	if (testUserName == null) {  
document.REPLIER.UserName.focus();
	} else {
	document.REPLIER.UserName.value = getCookie("UserNameCP");
document.REPLIER.Password.value = getCookie("PasswordCP");
	}
}  else {
document.REPLIER.UserName.focus();
}

function getCookie(name){
var cname = name + "=";               
var dc = document.cookie;
if (dc.length > 0) {              
    begin = dc.indexOf(cname);
	 if (begin != -1) {           
        begin += cname.length;
		end = dc.indexOf(";", begin);
            if (end == -1) end = dc.length;
            return unescape(dc.substring(begin, end));        }
}
return null;
}

// STOP HIDING FROM OTHER BROWSERS -->
</SCRIPT>

</ul>
<P>
</body></html>
HTMLalice

}  #end Edit sr

sub DateTable {

$MonthName = shift;
$DayName = shift;
$YearName = shift;

if (($EditEndYear ne "") && ($MonthName =~ /End/)) {
$Year = $EditEndYear;
}
if (($EditStartYear ne "") && ($MonthName =~ /Start/)) {
$Year = $EditStartYear;
}

if ($MonthName =~ /Start/) {
$StartMonthSelect = ("StartMonth" . "$StartMonth" . "Select");
$$StartMonthSelect = "SELECTED";
$EndMonthSelect = ("EndMonth" . "$EndMonth" . "Select");
$$EndMonthSelect = "";
$StartDaySelect = ("StartDay" . "$StartDay" . "Select");
$$StartDaySelect = "SELECTED";
$EndDaySelect = ("EndDay" . "$EndDay" . "Select");
$$EndDaySelect = "";
}  else {
$EndMonthSelect = ("EndMonth" . "$EndMonth" . "Select");
$$EndMonthSelect = "SELECTED";
$StartMonthSelect = ("StartMonth" . "$StartMonth" . "Select");
$$StartMonthSelect = "";
$EndDaySelect = ("EndDay" . "$EndDay" . "Select");
$$EndDaySelect = "SELECTED";
$StartDaySelect = ("StartDay" . "$StartDay" . "Select");
$$StartDaySelect = "";

}
print<<DateTable;
<table border=0>
<TR>
<TD align=left><FONT FACE="Verdana" SIZE="1"><B>month</B></FONT></TD>
<td align=left><FONT FACE="Verdana" SIZE="1"><B>day</B></FONT></TD>
<td align=left><FONT FACE="Verdana" SIZE="1"><B>year</B></FONT></TD>
</tr>

<tr>
<TD><SELECT NAME="$MonthName">
   <OPTION VALUE="01" $EndMonth01Select $StartMonth01Select>January
   <OPTION VALUE="02" $EndMonth02Select $StartMonth02Select>February
   <OPTION VALUE="03" $EndMonth03Select $StartMonth03Select>March
   <OPTION VALUE="04" $EndMonth04Select $StartMonth04Select>April
   <OPTION VALUE="05" $EndMonth05Select $StartMonth05Select>May
   <OPTION VALUE="06" $EndMonth06Select $StartMonth06Select>June
   <OPTION VALUE="07" $EndMonth07Select $StartMonth07Select>July	
   <OPTION VALUE="08" $EndMonth08Select $StartMonth08Select>August
   <OPTION VALUE="09" $EndMonth09Select $StartMonth09Select>September
   <OPTION VALUE="10" $EndMonth10Select $StartMonth10Select>October
   <OPTION VALUE="11" $EndMonth11Select $StartMonth11Select>November
   <OPTION VALUE="12" $EndMonth12Select $StartMonth12Select>December
</SELECT></TD>

<td>
<SELECT NAME="$DayName">
   <OPTION VALUE="01" $EndDay01Select $StartDay01Select>1
   <OPTION VALUE="02" $EndDay02Select $StartDay02Select>2
   <OPTION VALUE="03" $EndDay03Select $StartDay03Select>3
   <OPTION VALUE="04" $EndDay04Select $StartDay04Select>4
   <OPTION VALUE="05" $EndDay05Select $StartDay05Select>5
   <OPTION VALUE="06" $EndDay06Select $StartDay06Select>6
   <OPTION VALUE="07" $EndDay07Select $StartDay07Select>7
   <OPTION VALUE="08" $EndDay08Select $StartDay08Select>8
   <OPTION VALUE="09" $EndDay09Select $StartDay09Select>9
   <OPTION VALUE="10" $EndDay10Select $StartDay10Select>10
   <OPTION VALUE="11" $EndDay11Select $StartDay11Select>11
   <OPTION VALUE="12" $EndDay12Select $StartDay12Select>12
   <OPTION VALUE="13" $EndDay13Select $StartDay13Select>13
   <OPTION VALUE="14" $EndDay14Select $StartDay14Select>14
   <OPTION VALUE="15" $EndDay15Select $StartDay15Select>15
   <OPTION VALUE="16" $EndDay16Select $StartDay16Select>16
   <OPTION VALUE="17" $EndDay17Select $StartDay17Select >17
   <OPTION VALUE="18" $EndDay18Select $StartDay18Select>18
   <OPTION VALUE="19" $EndDay19Select $StartDay19Select>19
   <OPTION VALUE="20" $EndDay20Select $StartDay20Select>20
   <OPTION VALUE="21" $EndDay21Select $StartDay21Select>21
   <OPTION VALUE="22" $EndDay22Select $StartDay22Select>22
   <OPTION VALUE="23" $EndDay23Select $StartDay23Select>23
   <OPTION VALUE="24" $EndDay24Select $StartDay24Select>24
   <OPTION VALUE="25" $EndDay25Select $StartDay25Select>25
   <OPTION VALUE="26" $EndDay26Select $StartDay26Select>26
   <OPTION VALUE="27" $EndDay27Select $StartDay27Select>27
   <OPTION VALUE="28" $EndDay28Select $StartDay28Select>28
   <OPTION VALUE="29" $EndDay29Select $StartDay29Select>29
   <OPTION VALUE="30" $EndDay30Select $StartDay30Select>30
<OPTION VALUE="31" $EndDay31Select $StartDay31Select>31
</SELECT>
</TD>
<TD>
<INPUT TYPE="Text" NAME="$YearName" SIZE="4" VALUE="$Year" MAXLENGTH="4">
</TD>
</TR>
</TABLE>
DateTable
}



sub CheckStatus {

		if ($Status =~ m/Administrator/)  {
			$AdminStatus = "true";
		} else {
			$AdminStatus = "false";
		}
		
		if ($Status =~ m/Moderator/)  {
			$ModStatus = "true";
		} else {
			$ModStatus = "false";
		}
	

} #end CheckStatus


sub GetForumAnnouncements {
my $ForumNums = shift;

$cumulative = "";
&GetDateTime;  #getting current jules time -$LastLoginTime

if ($ForumNums =~ m/\|/) {
chomp($ForumNums);
@forumnums = split(/\|/, $ForumNums);
}  else {
@forumnums = $ForumNums;
}

@sortforums = sort(@forumnums);
foreach $fornumber(@forumnums) {
$zilla = $fornumber;

&GetExactPath("$zilla");

opendir (GETANNC, "$ForumsPath/$ExactPath/ANNC");
	my @forummsgs = readdir(GETANNC);
closedir (GETANNC);
	my @announcements = grep(/annc/, @forummsgs);

#now we have all announcements in the forums
	$announce = "";
	
	foreach $announce(@announcements) {
		my ($start, $end, $trashit) = split("-", $announce);
		($sever, $trash4) = split(/\./, $trashit);
		&DateCompare("$start", "$end");

	if ($Dead eq "true") {
		#delete any old announcements!
		unlink ("$ForumsPath/$ExactPath/ANNC/$announce");
		}  else {
			unless ($cumulative =~ m/$announce/s) {
			
		$sortline = ("$StartJulian|$fornumber|$announce");
			
		push (@annclist, $sortline);
		$cumulative .= "$announce";
			}
	}
	} # end foreach
} #end foreach

	#now we have our array of announcements
	@sortedannc = sort(@annclist);

#remove duplicates
foreach $line(@annclist) {
@checkit = split(/\|/, $line);
}

for $onebyone(@sortedannc) {

	($trash, $forumno, $anncfile) = split(/\|/, $onebyone);
	&GetExactPath($forumno);
@anncinfo = &OpenFile("$ForumsPath/$ExactPath/ANNC/$anncfile");
#format end date
($startdate, $enddate, $trash2) = split("-", $anncfile);
my $EndMonth = substr($enddate, 0, 2);
my $EndDay = substr($enddate, 2, 2);
my $EndYear = substr($enddate, 6, 2);
my $StartMonth = substr($startdate, 0, 2);
my $StartDay = substr($startdate, 2, 2);
my $StartYear = substr($startdate, 6, 2);

if (($DateFormat eq "US") || ($DateFormat eq "USX")) {
$FormatEnd = ("$EndMonth/$EndDay/$EndYear");
$FormatStart = ("$StartMonth/$StartDay/$StartYear");
}  else {
$FormatEnd = ("$EndDay/$EndMonth/$EndYear");
$FormatStart = ("$StartDay/$StartMonth/$StartYear");
}

$Author = $anncinfo[0];
$Subject = $anncinfo[1];
$Status = $anncinfo[2];
$ForumList = $anncinfo[3];
$Message	 = $anncinfo[4];
chomp($Author);
chomp($Subject);
chomp($Status);
chomp($ForumList);
chomp($Message);

$ForumList =~ s/\|/, /isg;

#print HTML for each announcement
print<<ROW;
<TR bgcolor="#dedfdf">
<TD>
<INPUT TYPE="RADIO" NAME="EditAnnounce" VALUE="$ForumsPath/$ExactPath/ANNC/$anncfile">
</td>
<td>
<FONT SIZE="2" FACE="Verdana, Arial">$Subject</FONT>
</td>
<td><FONT SIZE="2" FACE="Verdana, Arial">
$ForumList</FONT>
</td>
<td><FONT SIZE="2" FACE="Verdana, Arial">
$FormatStart</FONT>
</td>
<td><FONT SIZE="2" FACE="Verdana, Arial">
$FormatEnd</FONT>
</td>
</tr>
ROW

} #end foreach $onebyone sr

} #end GetForumAnnouncements sr

exit(0); # comply with SafePerl

